/* This file is automatically generated. */
/* DO NOT EDIT. */

#pragma once

/*****************************************************************************/
/*                              Legal                                        */
/*****************************************************************************/

/*
** Copyright 2015-2024, Lantronix, Inc. All Rights Reserved.
** By using this software, you are agreeing to the terms of the Software
** Development Kit (SDK) License Agreement included in the distribution package
** for this software (the License Agreement).
** Under the License Agreement, this software may be used solely to create
** custom applications for use on the Lantronix xPico Wi-Fi product.
** THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS PROVIDED "AS IS".
** LANTRONIX SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED
** TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT AND FITNESS
** FOR A PARTICULAR PURPOSE.
** LANTRONIX HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
** ENHANCEMENTS, OR MODIFICATIONS TO THIS SOFTWARE.
** IN NO EVENT SHALL LANTRONIX BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
** SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS,
** ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
** LANTRONIX HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*****************************************************************************/
/*                             Includes                                      */
/*****************************************************************************/

#include <stdarg.h>
#include <stdint.h>
#include <stdbool.h>
#include "ltrx_cfgvar.h"

/*****************************************************************************/
/*                       Generated Definitions                               */
/*****************************************************************************/

/* From define_external_include declarations: */
                                                                                                                    
                                                                                                        
/* Structures referenced by define_external_function declarations: */                                                                                                                    
                                                                                                        

struct azure_iot_external_functions
{
    bool (*ltrx_azure_direct_method_register)(
        const char *method_name,
        unsigned int (*method)(const char *payload, size_t payloadLength, char *reply, size_t *replyLength)
    );
    bool (*ltrx_azure_iot_send)(
        const void *data,
        size_t data_length
    );                                                                                                                    
                                                                                                        
};

/* From vardef declarations: */

/* Begin index Azure */
#define VARDEF_ELEMENT_GROUP_AZURE 1  
    
#define VARDEF_ELEMENT_ITEM_AZURE_STATE 2
#define VARDEF_NUMBER_380_HAS_ALREADY_BEEN_USED azure_iot-2 
    
/* Begin index -AzureConnInfo */
#define VARDEF_ELEMENT_GROUP_AZURE__AZURECONNINFO 3  
        
#define VARDEF_ELEMENT_ITEM_AZURE__AZURECONNINFO_HUB_NAME 4
#define VARDEF_NUMBER_381_HAS_ALREADY_BEEN_USED azure_iot-4  
#define VARDEF_ELEMENT_ITEM_AZURE__AZURECONNINFO_HUB_NAME_STRLEN_MAX 64
        
#define VARDEF_ELEMENT_ITEM_AZURE__AZURECONNINFO_DEVICE_ID 5
#define VARDEF_NUMBER_382_HAS_ALREADY_BEEN_USED azure_iot-5  
#define VARDEF_ELEMENT_ITEM_AZURE__AZURECONNINFO_DEVICE_ID_STRLEN_MAX 128
        
#define VARDEF_ENUM_AZURE__AZURECONNINFO_SECURITY__SECURITY_KEYS 0

#define VARDEF_ENUM_AZURE__AZURECONNINFO_SECURITY__X_509_CERTIFICATE 1


#define VARDEF_ELEMENT_ITEM_AZURE__AZURECONNINFO_SECURITY 6
#define VARDEF_NUMBER_383_HAS_ALREADY_BEEN_USED azure_iot-6 
        
/* Begin index -SASValue */
#define VARDEF_ELEMENT_GROUP_AZURE__AZURECONNINFO__SASVALUE 7  
            
#define VARDEF_ELEMENT_ITEM_AZURE__AZURECONNINFO__SASVALUE_SAS_TOKEN 8
#define VARDEF_NUMBER_384_HAS_ALREADY_BEEN_USED azure_iot-8  
#define VARDEF_ELEMENT_ITEM_AZURE__AZURECONNINFO__SASVALUE_SAS_TOKEN_STRLEN_MAX 256
        
/* End index -SASValue */
#define VARDEF_ELEMENT_END_AZURE__AZURECONNINFO__SASVALUE 9  
        
/* Begin index -TLSName */
#define VARDEF_ELEMENT_GROUP_AZURE__AZURECONNINFO__TLSNAME 10  
            
#define VARDEF_ELEMENT_ITEM_AZURE__AZURECONNINFO__TLSNAME_CREDENTIAL_NAME 11
#define VARDEF_NUMBER_385_HAS_ALREADY_BEEN_USED azure_iot-11  
#define VARDEF_ELEMENT_ITEM_AZURE__AZURECONNINFO__TLSNAME_CREDENTIAL_NAME_STRLEN_MAX 256
        
/* End index -TLSName */
#define VARDEF_ELEMENT_END_AZURE__AZURECONNINFO__TLSNAME 12  
        

#define VARDEF_ELEMENT_ITEM_AZURE__AZURECONNINFO_MQTT_LOCAL_PORT 13
#define VARDEF_NUMBER_386_HAS_ALREADY_BEEN_USED azure_iot-13 
        

#define VARDEF_ELEMENT_ITEM_AZURE__AZURECONNINFO_RECEIVE_BUFFER 14
#define VARDEF_NUMBER_388_HAS_ALREADY_BEEN_USED azure_iot-14 
        

#define VARDEF_ELEMENT_ITEM_AZURE__AZURECONNINFO_REPLY_BUFFER 15
#define VARDEF_NUMBER_387_HAS_ALREADY_BEEN_USED azure_iot-15 
    
/* End index -AzureConnInfo */
#define VARDEF_ELEMENT_END_AZURE__AZURECONNINFO 16  

struct vardef_values_azure;
bool AzureTestSet(
    uint32_t zeroBasedIndex,
    struct vardef_values_azure *config,
    bool set,
    const struct ltrx_write_user_message_info *lwumi
);
void AzureWarnings(
    uint32_t zeroBasedIndex,
    const struct ltrx_write_user_message_info *lwumi
);
/* End index Azure */
#define VARDEF_ELEMENT_END_AZURE 17  

                                                                                                        
/* Structures for groups of data */

                                                                                                                                    
                                                                                                                                                                                                                                            
                                                                                                                                                                                                                                            
                                                                                                                                                        
struct vardef_values_azure__azureconninfo__sasvalue {                
    char sas_token[256 + 1];        
};
        
struct vardef_values_azure__azureconninfo__tlsname {                
    char credential_name[256 + 1];        
};
                            
                                                                                                                
struct vardef_values_azure__azureconninfo {            
    char hub_name[64 + 1];            
    char device_id[128 + 1];        
    uint8_t security;        
    struct vardef_values_azure__azureconninfo__sasvalue _sasvalue;                                
    struct vardef_values_azure__azureconninfo__tlsname _tlsname;                                
    uint16_t mqtt_local_port;        
    uint16_t receive_buffer;        
    uint16_t reply_buffer;    
};

                                                                                                        
struct vardef_values_azure {    
    bool state;    
    struct vardef_values_azure__azureconninfo _azureconninfo;                                                                                                                            
};

                                                                                                        
/* From statusdef declarations: */
                                                                                                                    
 
#define STATUSDEF_ELEMENT_GROUP_AZURE 1 
    
#define STATUSDEF_ELEMENT_ITEM_AZURE_STATE 2 
#define STATUSDEF_ENUM_AZURE_STATE__DOWN 0 
#define STATUSDEF_ENUM_AZURE_STATE__CONNECTING 1 
#define STATUSDEF_ENUM_AZURE_STATE__UP 2 
    
#define STATUSDEF_ELEMENT_ITEM_AZURE_ATTACHED_LINE 3  
#define STATUSDEF_ELEMENT_ITEM_AZURE_ATTACHED_LINE_STRLEN_MAX 20
     
#define STATUSDEF_ELEMENT_GROUP_AZURE__AZUREIOTGROUP 4 
        
#define STATUSDEF_ELEMENT_ITEM_AZURE__AZUREIOTGROUP_UPTIME 5 
    
/* End index -AzureIoTGroup */ 
#define STATUSDEF_ELEMENT_END_AZURE__AZUREIOTGROUP 6     
#define STATUSDEF_ELEMENT_ITEM_AZURE_CONNECTIONS 7 
    
#define STATUSDEF_ELEMENT_ITEM_AZURE_CONNECT_FAIL 8 
     
#define STATUSDEF_ELEMENT_GROUP_AZURE_DEVICE 9 
        
#define STATUSDEF_ELEMENT_ITEM_AZURE_DEVICE_TOTAL_OUT 10 
        
#define STATUSDEF_ELEMENT_ITEM_AZURE_DEVICE_OUT_FAIL 11 
        
#define STATUSDEF_ELEMENT_ITEM_AZURE_DEVICE_TOTAL_IN 12 
        
#define STATUSDEF_ELEMENT_ITEM_AZURE_DEVICE_IN_DROPPED 13 
    
/* End index Device */ 
#define STATUSDEF_ELEMENT_END_AZURE_DEVICE 14      
#define STATUSDEF_ELEMENT_GROUP_AZURE_DIRECT_METHOD 15 
        
#define STATUSDEF_ELEMENT_ITEM_AZURE_DIRECT_METHOD_HANDLED 16 
        
#define STATUSDEF_ELEMENT_ITEM_AZURE_DIRECT_METHOD_UNKNOWN 17 
        
#define STATUSDEF_ELEMENT_ITEM_AZURE_DIRECT_METHOD_MALFORMED 18 
    
/* End index Direct Method */ 
#define STATUSDEF_ELEMENT_END_AZURE_DIRECT_METHOD 19 
/* End index Azure */
struct statusdef_values_azure;
void AzureGetStatus(
    uint32_t zeroBasedIndex,
    struct statusdef_values_azure *status,
    const struct ltrx_write_user_message_info *lwumi
); 
#define STATUSDEF_ELEMENT_END_AZURE 20 
/* Structures for groups of status */

                                                                                                                    
                                                                                                                                                                                                                                
                                                                                                                                                                                                                                
                                                                                                                                                                                                                                
                                                                                                                                                                                                                                
                
struct statusdef_values_azure__azureiotgroup {        
    uint64_t uptime;    
};
            
struct statusdef_values_azure_device {        
    uint64_t total_out;        
    uint64_t out_fail;        
    uint64_t total_in;        
    uint64_t in_dropped;    
};
    
struct statusdef_values_azure_direct_method {        
    uint64_t handled;        
    uint64_t unknown;        
    uint64_t malformed;    
};
                                                                                                                    

struct statusdef_values_azure {    
    uint8_t state;        
    char attached_line[20 + 1];    
    struct statusdef_values_azure__azureiotgroup _azureiotgroup;                
    uint64_t connections;    
    uint64_t connect_fail;    
    struct statusdef_values_azure_device device;                                        
    struct statusdef_values_azure_direct_method direct_method;                            
};

extern const struct ltrx_module_info g_azure_iotModuleInfo;

