/* This file is automatically generated. */
/* DO NOT EDIT. */

#pragma once

/*****************************************************************************/
/*                              Legal                                        */
/*****************************************************************************/

/*
** Copyright 2015-2024, Lantronix, Inc. All Rights Reserved.
** By using this software, you are agreeing to the terms of the Software
** Development Kit (SDK) License Agreement included in the distribution package
** for this software (the License Agreement).
** Under the License Agreement, this software may be used solely to create
** custom applications for use on the Lantronix xPico Wi-Fi product.
** THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS PROVIDED "AS IS".
** LANTRONIX SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED
** TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT AND FITNESS
** FOR A PARTICULAR PURPOSE.
** LANTRONIX HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
** ENHANCEMENTS, OR MODIFICATIONS TO THIS SOFTWARE.
** IN NO EVENT SHALL LANTRONIX BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
** SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS,
** ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
** LANTRONIX HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*****************************************************************************/
/*                             Includes                                      */
/*****************************************************************************/

#include <stdarg.h>
#include <stdint.h>
#include <stdbool.h>
#include "ltrx_cfgvar.h"

/*****************************************************************************/
/*                       Generated Definitions                               */
/*****************************************************************************/

/* From define_external_include declarations: */


#include "ltrx_bluetooth.h"

#include "ltrx_gatt.h"



















































                                                                                                                                                                    
    
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    

/* Structures referenced by define_external_function declarations: */





struct ltrx_bonded_device;


struct bluetooth_device;












struct ltrx_ble_advert_filter;
struct ltrx_ble_advert;



struct ltrx_gatt_server;










struct ltrx_uuid;
struct ltrx_gatt_disc_service;

struct ltrx_gatt_handle_range;
struct ltrx_gatt_disc_characteristic;

struct ltrx_gatt_disc_descriptor;

















                                                                                                                                                                    
    
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    


struct bluetooth_external_functions
{



    enum ltrx_bluetooth_state (*ltrx_bluetooth_get_state)(
        void

    );

    bool (*ltrx_bluetooth_register_pairing_events)(
        void (*pairing_event_callback)(const uint8_t [], bool, void *),
        void *arg

    );

    uint8_t (*ltrx_bluetooth_get_bonded_devices)(
        struct ltrx_bonded_device *devices,
        uint8_t *count

    );

    bool (*ltrx_bluetooth_is_device_bonded)(
        const uint8_t device_address[6]

    );

    bool (*ltrx_bluetooth_get_cached_peer)(
        const uint8_t device_address[6],
        struct bluetooth_device *device

    );


    bool (*ltrx_rfcomm_get_service_channels)(
        const uint8_t device_address[6],
        uint16_t service_uuid,
        uint8_t scn[],
        uint8_t scn_count

    );

    uint16_t (*ltrx_rfcomm_connect)(
        const uint8_t device_address[6],
        uint16_t uuid,
        uint8_t scn,
        void (*connection_callback)(const uint8_t [], int, uint16_t, void *),
        void *arg

    );

    uint16_t (*ltrx_rfcomm_accept)(
        uint16_t uuid,
        void (*connection_callback)(const uint8_t [], int, uint16_t, void *),
        void *arg

    );

    bool (*ltrx_rfcomm_disconnect)(
        uint16_t port_handle

    );

    void (*ltrx_rfcomm_register_read_callback)(
        int (*rfcomm_read_callback)(uint16_t, void *, uint16_t),
        uint16_t port_handle

    );

    void (*ltrx_rfcomm_register_event_callback)(
        void (*rfcomm_event_callback)(int, uint16_t),
        uint16_t port_handle

    );

    bool (*ltrx_rfcomm_write)(
        uint16_t port_handle,
        const void *data,
        uint16_t *size

    );

    void (*ltrx_rfcomm_control)(
        uint16_t port_handle,
        uint32_t signal

    );

    void (*ltrx_rfcomm_flow_control)(
        uint16_t port_handle,
        bool enable

    );


    bool (*ltrx_ble_advert_notification_register)(
        const struct ltrx_ble_advert_filter *filter,
        void (*advert_notification_callback)(const struct ltrx_ble_advert *, void *),
        void *

    );

    void (*ltrx_ble_advert_notification_unregister)(
        void (*advert_notification_callback)(const struct ltrx_ble_advert *, void *)

    );


    bool (*ltrx_gatt_register_server)(
        const struct ltrx_gatt_server *server

    );

    bool (*ltrx_gatt_unregister_server)(
        const struct ltrx_gatt_server *server

    );

    enum ltrx_gatt_status (*ltrx_gatt_send_response)(
        uint16_t connection_id,
        enum ltrx_gatt_status status,
        uint16_t handle,
        const uint8_t *data,
        uint16_t length,
        uint16_t offset

    );

    bool (*ltrx_gatt_send_notification)(
        uint16_t connection_id,
        uint16_t handle,
        const uint8_t *data,
        uint16_t length

    );

    bool (*ltrx_gatt_send_indication)(
        uint16_t connection_id,
        uint16_t handle,
        const uint8_t *data,
        uint16_t length

    );


    enum ltrx_gatt_status (*ltrx_gatt_connect)(
        const uint8_t bda[6],
        uint8_t transport,
        enum ble_address_type ble_address_type,
        void (*gatt_connect_callback)(
        const uint8_t bda[6], bool connected, uint16_t connection_id, void *arg
    ),
        void *arg

    );

    bool (*ltrx_gatt_connect_cancel)(
        const uint8_t bda[6]

    );

    bool (*ltrx_gatt_disconnect)(
        uint16_t connection_id

    );

    bool (*ltrx_gatt_configure_mtu)(
        uint16_t connection_id,
        uint16_t mtu,
        uint32_t timeout

    );

    bool (*ltrx_gatt_discover_services)(
        uint16_t connection_id,
        const struct ltrx_uuid *optional_uuid,
        struct ltrx_gatt_disc_service **service_arrayp,
        uint16_t *service_countp,
        uint32_t timeout

    );

    bool (*ltrx_gatt_discover_characteristics)(
        uint16_t connection_id,
        const struct ltrx_gatt_handle_range *optional_hr,
        struct ltrx_gatt_disc_characteristic **characteristic_arrayp,
        uint16_t *characteristic_count,
        uint32_t timeout

    );

    bool (*ltrx_gatt_discover_characteristic_descriptors)(
        uint16_t connection_id,
        const struct ltrx_gatt_handle_range *optional_hr,
        struct ltrx_gatt_disc_descriptor **descriptor_arrayp,
        uint16_t *descriptor_count,
        uint32_t timeout

    );

    enum ltrx_gatt_status (*ltrx_gatt_read_by_handle)(
        uint16_t connection_id,
        uint16_t handle,
        uint8_t *buffer,
        uint16_t offset,
        uint16_t *lengthp,
        uint32_t timeout

    );

    enum ltrx_gatt_status (*ltrx_gatt_read_by_type)(
        uint16_t connection_id,
        const struct ltrx_gatt_handle_range *hr,
        const struct ltrx_uuid *uuid,
        uint8_t *buffer,
        uint16_t *lengthp,
        uint32_t timeout

    );

    enum ltrx_gatt_status (*ltrx_gatt_write)(
        uint16_t connection_id,
        uint16_t handle,
        uint8_t *data,
        uint16_t offset,
        uint16_t length,
        enum ltrx_gatt_write_type type

    );

    enum ltrx_gatt_status (*ltrx_gatt_prepared_write_execute)(
        uint16_t connection_id

    );

    enum ltrx_gatt_status (*ltrx_gatt_prepared_write_cancel)(
        uint16_t connection_id

    );

    bool (*ltrx_gatt_notification_register)(
        const struct ltrx_gatt_handle_range *hr,
        void (*notification_callback)(uint16_t connection_id, uint16_t handle, uint8_t *data, uint16_t length, uint16_t offset, void *opaque),
        void *opaque

    );

    void (*ltrx_gatt_notification_unregister)(
        void (*notification_callback)(uint16_t connection_id, uint16_t handle, uint8_t *data, uint16_t length, uint16_t offset, void *opaque)

    );

    bool (*ltrx_gatt_indication_register)(
        const struct ltrx_gatt_handle_range *hr,
        void (*notification_callback)(uint16_t connection_id, uint16_t handle, uint8_t *data, uint16_t length, uint16_t offset, void *opaque),
        void *opaque

    );

    void (*ltrx_gatt_indication_unregister)(
        void (*notification_callback)(uint16_t connection_id, uint16_t handle, uint8_t *data, uint16_t length, uint16_t offset, void *opaque)

    );

    enum ltrx_gatt_status (*ltrx_gatt_confirm_indication)(
        uint16_t connection_id,
        uint16_t handle

    );







                                                                                                                                                                    
    
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    

};

/* From vardef declarations: */





















































/* Begin index Bluetooth */
#define VARDEF_ELEMENT_GROUP_BLUETOOTH 1  
    
#define VARDEF_ELEMENT_ITEM_BLUETOOTH_STATE 2
#define VARDEF_NUMBER_320_HAS_ALREADY_BEEN_USED bluetooth-2 
    
#define VARDEF_ELEMENT_ITEM_BLUETOOTH_DEVICE_NAME 3
#define VARDEF_NUMBER_314_HAS_ALREADY_BEEN_USED bluetooth-3  
#define VARDEF_ELEMENT_ITEM_BLUETOOTH_DEVICE_NAME_STRLEN_MAX 25
    
#define VARDEF_ELEMENT_ITEM_BLUETOOTH_DEVICE_CLASS 4
#define VARDEF_NUMBER_323_HAS_ALREADY_BEEN_USED bluetooth-4  
#define VARDEF_ELEMENT_ITEM_BLUETOOTH_DEVICE_CLASS_LENGTH_MAX 3
    
#define VARDEF_ELEMENT_ITEM_BLUETOOTH_BACKGROUND_SCANNING 5
#define VARDEF_NUMBER_315_HAS_ALREADY_BEEN_USED bluetooth-5 
    
#define VARDEF_ENUM_BLUETOOTH_ALLOW_DISCOVERY__NO 0

#define VARDEF_ENUM_BLUETOOTH_ALLOW_DISCOVERY__YES 1


#define VARDEF_ELEMENT_ITEM_BLUETOOTH_ALLOW_DISCOVERY 6
#define VARDEF_NUMBER_311_HAS_ALREADY_BEEN_USED bluetooth-6 
    
#define VARDEF_ENUM_BLUETOOTH_ALLOW_CONNECTIONS__NO 0

#define VARDEF_ENUM_BLUETOOTH_ALLOW_CONNECTIONS__YES 1


#define VARDEF_ELEMENT_ITEM_BLUETOOTH_ALLOW_CONNECTIONS 7
#define VARDEF_NUMBER_317_HAS_ALREADY_BEEN_USED bluetooth-7 
    
/* Begin index -SlaveConfig */
#define VARDEF_ELEMENT_GROUP_BLUETOOTH__SLAVECONFIG 8  
        
/* Suppressed index -LegacyPairing */
            
            
/* Suppressed index -PINConfig */
                 
            
        
        
#define VARDEF_ENUM_BLUETOOTH__SLAVECONFIG_ENABLE_SPP_SERVER__NO 0

#define VARDEF_ENUM_BLUETOOTH__SLAVECONFIG_ENABLE_SPP_SERVER__YES 1


#define VARDEF_ELEMENT_ITEM_BLUETOOTH__SLAVECONFIG_ENABLE_SPP_SERVER 9
#define VARDEF_NUMBER_316_HAS_ALREADY_BEEN_USED bluetooth-9 
        
/* Begin index -SPPConfig */
#define VARDEF_ELEMENT_GROUP_BLUETOOTH__SLAVECONFIG__SPPCONFIG 10  
            

#define VARDEF_ELEMENT_ITEM_BLUETOOTH__SLAVECONFIG__SPPCONFIG_SPP_SERVICE_CHANNEL 11
#define VARDEF_NUMBER_318_HAS_ALREADY_BEEN_USED bluetooth-11 
        
/* End index -SPPConfig */
#define VARDEF_ELEMENT_END_BLUETOOTH__SLAVECONFIG__SPPCONFIG 12  
    
/* End index -SlaveConfig */
#define VARDEF_ELEMENT_END_BLUETOOTH__SLAVECONFIG 13  
    
#define VARDEF_ENUM_BLUETOOTH_ENABLE_BLE_PERIPHERAL__NO 0

#define VARDEF_ENUM_BLUETOOTH_ENABLE_BLE_PERIPHERAL__YES 1


#define VARDEF_ELEMENT_ITEM_BLUETOOTH_ENABLE_BLE_PERIPHERAL 14
#define VARDEF_NUMBER_321_HAS_ALREADY_BEEN_USED bluetooth-14 
    
/* Begin index -PeripheralConfig */
#define VARDEF_ELEMENT_GROUP_BLUETOOTH__PERIPHERALCONFIG 15  
        
#define VARDEF_ELEMENT_ITEM_BLUETOOTH__PERIPHERALCONFIG_LANTRONIX_PROVISIONING_SERVER 16
#define VARDEF_NUMBER_322_HAS_ALREADY_BEEN_USED bluetooth-16 
        
#define VARDEF_ELEMENT_ITEM_BLUETOOTH__PERIPHERALCONFIG_BLE_PERIPHERAL_DEVICE_NAME 17
#define VARDEF_NUMBER_326_HAS_ALREADY_BEEN_USED bluetooth-17  
#define VARDEF_ELEMENT_ITEM_BLUETOOTH__PERIPHERALCONFIG_BLE_PERIPHERAL_DEVICE_NAME_STRLEN_MAX 25
    
/* End index -PeripheralConfig */
#define VARDEF_ELEMENT_END_BLUETOOTH__PERIPHERALCONFIG 18  

struct vardef_values_bluetooth;
bool BluetoothTestSet(
    uint32_t zeroBasedIndex,
    struct vardef_values_bluetooth *config,
    bool set,
    const struct ltrx_write_user_message_info *lwumi
);
void BluetoothWarnings(
    uint32_t zeroBasedIndex,
    const struct ltrx_write_user_message_info *lwumi
);
/* End index Bluetooth */
#define VARDEF_ELEMENT_END_BLUETOOTH 19  


/* Begin index Bluetooth Devices */
#define VARDEF_ELEMENT_GROUP_BLUETOOTH_DEVICES 20  
    
#define VARDEF_ELEMENT_ITEM_BLUETOOTH_DEVICES_BOND_DATA 21
#define VARDEF_NUMBER_255_HAS_ALREADY_BEEN_USED bluetooth-21  
#define VARDEF_ELEMENT_ITEM_BLUETOOTH_DEVICES_BOND_DATA_LENGTH_MAX 180

/* End index Bluetooth Devices */
#define VARDEF_ELEMENT_END_BLUETOOTH_DEVICES 22  

                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    

/* Structures for groups of data */





















































                                                                                                                                                                                    
        
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    




















































                                                                                                                                                                                    
        
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    




















































                                                                                                                                                                                    
        
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    




















































                                                                                                                            
struct vardef_values_bluetooth__slaveconfig__sppconfig {            
    uint8_t spp_service_channel;        
};
                                    
        
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    




















































                                    
struct vardef_values_bluetooth__slaveconfig {                                                                                
    uint8_t enable_spp_server;        
    struct vardef_values_bluetooth__slaveconfig__sppconfig _sppconfig;                        
};
        
struct vardef_values_bluetooth__peripheralconfig {        
    bool lantronix_provisioning_server;            
    char ble_peripheral_device_name[25 + 1];    
};

        
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    





















































struct vardef_values_bluetooth {    
    bool state;        
    char device_name[25 + 1];        
    struct {
        uint16_t length;
        uint8_t data[3];
    } device_class;    
    bool background_scanning;    
    uint8_t allow_discovery;    
    uint8_t allow_connections;    
    struct vardef_values_bluetooth__slaveconfig _slaveconfig;                                                                                                                    
    uint8_t enable_ble_peripheral;    
    struct vardef_values_bluetooth__peripheralconfig _peripheralconfig;                        
};


struct vardef_values_bluetooth_devices {        
    struct {
        uint16_t length;
        uint8_t data[180];
    } bond_data;
};

                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    

/* From statusdef declarations: */




















































                                                                                                                                                                    
    
 
#define STATUSDEF_ELEMENT_GROUP_BLUETOOTH 1 
     
#define STATUSDEF_ELEMENT_GROUP_BLUETOOTH_OPERATION 2 
        
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION_STATE 3 
#define STATUSDEF_ENUM_BLUETOOTH_OPERATION_STATE__DISABLED 0 
#define STATUSDEF_ENUM_BLUETOOTH_OPERATION_STATE__ENABLED 1 
         
#define STATUSDEF_ELEMENT_GROUP_BLUETOOTH_OPERATION__CONTENTS 4 
            
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_LOCAL_DEVICE_ADDRESS 5  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_LOCAL_DEVICE_ADDRESS_STRLEN_MAX 17
            
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_NUMBER_OF_RFCOMM_SERVERS 6 
             
#define STATUSDEF_ELEMENT_GROUP_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_SERVER 7 
                 
/* statusdef_index_information 8 */ 
                 
/* statusdef_summary 9 */ 
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_SERVER_NAME 10  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_SERVER_NAME_STRLEN_MAX 25
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_SERVER_SERVICE_UUID 11  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_SERVER_SERVICE_UUID_STRLEN_MAX 36
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_SERVER_SERVICE_CHANNEL_NUMBER 12 
            
/* End index RFCOMM Server */ 
#define STATUSDEF_ELEMENT_END_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_SERVER 13             
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_NUMBER_OF_RFCOMM_CONNECTIONS 14 
             
#define STATUSDEF_ELEMENT_GROUP_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_CONNECTION 15 
                 
/* statusdef_index_information 16 */ 
                 
/* statusdef_summary 17 */ 
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_CONNECTION_REMOTE_DEVICE_ADDRESS 18  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_CONNECTION_REMOTE_DEVICE_ADDRESS_STRLEN_MAX 17
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_CONNECTION_SERVICE 19  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_CONNECTION_SERVICE_STRLEN_MAX 15
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_CONNECTION_SERVICE_CHANNEL_NUMBER 20 
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_CONNECTION_TYPE 21  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_CONNECTION_TYPE_STRLEN_MAX 19
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_CONNECTION_TIME_CONNECTED 22  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_CONNECTION_TIME_CONNECTED_STRLEN_MAX 64
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_CONNECTION_DISCONNECT 23 
            
/* End index RFCOMM Connection */ 
#define STATUSDEF_ELEMENT_END_BLUETOOTH_OPERATION__CONTENTS_RFCOMM_CONNECTION 24             
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_BLE_ADVERTISED_SERVICE_UUID 25  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_BLE_ADVERTISED_SERVICE_UUID_STRLEN_MAX 36
            
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_NUMBER_OF_GATT_SERVERS 26 
             
#define STATUSDEF_ELEMENT_GROUP_BLUETOOTH_OPERATION__CONTENTS_GATT_SERVER 27 
                 
/* statusdef_index_information 28 */ 
                 
/* statusdef_summary 29 */ 
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_GATT_SERVER_NAME 30  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_GATT_SERVER_NAME_STRLEN_MAX 20
                 
#define STATUSDEF_ELEMENT_GROUP_BLUETOOTH_OPERATION__CONTENTS_GATT_SERVER_SERVICE 31 
                    
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_GATT_SERVER_SERVICE_UUID 32  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_GATT_SERVER_SERVICE_UUID_STRLEN_MAX 36
                
/* End index Service */ 
#define STATUSDEF_ELEMENT_END_BLUETOOTH_OPERATION__CONTENTS_GATT_SERVER_SERVICE 33             
/* End index GATT Server */ 
#define STATUSDEF_ELEMENT_END_BLUETOOTH_OPERATION__CONTENTS_GATT_SERVER 34             
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_NUMBER_OF_GATT_CONNECTIONS 35 
             
#define STATUSDEF_ELEMENT_GROUP_BLUETOOTH_OPERATION__CONTENTS_GATT_CONNECTION 36 
                 
/* statusdef_index_information 37 */ 
                 
/* statusdef_summary 38 */ 
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_GATT_CONNECTION_ADDRESS_TYPE 39  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_GATT_CONNECTION_ADDRESS_TYPE_STRLEN_MAX 23
                 
#define STATUSDEF_ELEMENT_GROUP_BLUETOOTH_OPERATION__CONTENTS_GATT_CONNECTION__ADDRESS 40 
                    
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_GATT_CONNECTION__ADDRESS_REMOTE_DEVICE_ADDRESS 41  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_GATT_CONNECTION__ADDRESS_REMOTE_DEVICE_ADDRESS_STRLEN_MAX 17
                
/* End index -Address */ 
#define STATUSDEF_ELEMENT_END_BLUETOOTH_OPERATION__CONTENTS_GATT_CONNECTION__ADDRESS 42                 
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_GATT_CONNECTION_TRANSPORT 43  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_GATT_CONNECTION_TRANSPORT_STRLEN_MAX 15
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_GATT_CONNECTION_CONNECTION_ID 44 
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_GATT_CONNECTION_MTU 45 
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_GATT_CONNECTION_TIME_CONNECTED 46  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_GATT_CONNECTION_TIME_CONNECTED_STRLEN_MAX 64
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_GATT_CONNECTION_DISCONNECT 47 
            
/* End index GATT Connection */ 
#define STATUSDEF_ELEMENT_END_BLUETOOTH_OPERATION__CONTENTS_GATT_CONNECTION 48             
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_NUMBER_OF_PAIRED_DEVICES 49 
             
#define STATUSDEF_ELEMENT_GROUP_BLUETOOTH_OPERATION__CONTENTS_PAIRED_DEVICE 50 
                 
/* statusdef_summary 51 */ 
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_PAIRED_DEVICE_NAME 52  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_PAIRED_DEVICE_NAME_STRLEN_MAX 25
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_PAIRED_DEVICE_ADDRESS 53  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION__CONTENTS_PAIRED_DEVICE_ADDRESS_STRLEN_MAX 17
            
/* End index Paired Device */ 
#define STATUSDEF_ELEMENT_END_BLUETOOTH_OPERATION__CONTENTS_PAIRED_DEVICE 54         
/* End index -Contents */ 
#define STATUSDEF_ELEMENT_END_BLUETOOTH_OPERATION__CONTENTS 55         
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION_SET_UNPAIR 56 
        
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_OPERATION_SET_ADDITIONAL_LOGGING 57 
    
/* End index Operation */
struct statusdef_values_bluetooth_operation;
void BluetoothState(
    uint32_t zeroBasedIndex,
    struct statusdef_values_bluetooth_operation *status,
    const struct ltrx_write_user_message_info *lwumi
); 
#define STATUSDEF_ELEMENT_END_BLUETOOTH_OPERATION 58      
#define STATUSDEF_ELEMENT_GROUP_BLUETOOTH_NEARBY_DEVICES 59 
         
#define STATUSDEF_ELEMENT_GROUP_BLUETOOTH_NEARBY_DEVICES__LIST 60 
             
#define STATUSDEF_ELEMENT_GROUP_BLUETOOTH_NEARBY_DEVICES__LIST_DEVICE 61 
                 
/* statusdef_summary 62 */ 
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_NEARBY_DEVICES__LIST_DEVICE_NAME 63  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_NEARBY_DEVICES__LIST_DEVICE_NAME_STRLEN_MAX 25
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_NEARBY_DEVICES__LIST_DEVICE_ADDRESS 64  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_NEARBY_DEVICES__LIST_DEVICE_ADDRESS_STRLEN_MAX 17
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_NEARBY_DEVICES__LIST_DEVICE_TYPE 65  
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_NEARBY_DEVICES__LIST_DEVICE_TYPE_STRLEN_MAX 29
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_NEARBY_DEVICES__LIST_DEVICE_RSSI 66 
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_NEARBY_DEVICES__LIST_DEVICE_SCALED_RSSI 67 
                
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_NEARBY_DEVICES__LIST_DEVICE_IS_BONDED 68 
#define STATUSDEF_ENUM_BLUETOOTH_NEARBY_DEVICES__LIST_DEVICE_IS_BONDED__NO 0 
#define STATUSDEF_ENUM_BLUETOOTH_NEARBY_DEVICES__LIST_DEVICE_IS_BONDED__YES 1 
            
/* End index Device */ 
#define STATUSDEF_ELEMENT_END_BLUETOOTH_NEARBY_DEVICES__LIST_DEVICE 69         
/* End index -List */ 
#define STATUSDEF_ELEMENT_END_BLUETOOTH_NEARBY_DEVICES__LIST 70         
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_NEARBY_DEVICES_SCAN 71 
        
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_NEARBY_DEVICES_SET_SORT_BY 72 
        
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_NEARBY_DEVICES_SET_PAIR 73 
        
#define STATUSDEF_ELEMENT_ITEM_BLUETOOTH_NEARBY_DEVICES_SET_UNPAIR 74 
    
/* End index Nearby Devices */
struct statusdef_values_bluetooth_nearby_devices;
void BluetoothDevicesStatus(
    uint32_t zeroBasedIndex,
    struct statusdef_values_bluetooth_nearby_devices *status,
    const struct ltrx_write_user_message_info *lwumi
); 
#define STATUSDEF_ELEMENT_END_BLUETOOTH_NEARBY_DEVICES 75 
/* End index Bluetooth */ 
#define STATUSDEF_ELEMENT_END_BLUETOOTH 76 

/* Structures for groups of status */





















































                                                                                                                                                                    
    
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                




















































                                                                                                                                                                    
    
                                                                                                                                                                                                                                                                                                                                                                                                                                                                
struct statusdef_values_bluetooth_operation__contents_gatt_server_service {                        
    char uuid[36 + 1];                
};
                                                                                                        
struct statusdef_values_bluetooth_operation__contents_gatt_connection__address {                        
    char remote_device_address[17 + 1];                
};
                                                                                                                                                                                                                                                                                                                                                                                                                                        




















































                                                                                                                                                                    
    
                                                            
struct statusdef_values_bluetooth_operation__contents_rfcomm_server {                                                    
    char name[25 + 1];                    
    char service_uuid[36 + 1];                
    uint8_t service_channel_number;            
};
                        
struct statusdef_values_bluetooth_operation__contents_rfcomm_connection {                                                    
    char remote_device_address[17 + 1];                    
    char service[15 + 1];                
    uint8_t service_channel_number;                    
    char type[19 + 1];                    
    char time_connected[64 + 1];                            
};
                                        
struct statusdef_values_bluetooth_operation__contents_gatt_server {                                                    
    char name[20 + 1];                
    struct statusdef_values_bluetooth_operation__contents_gatt_server_service service[3];                                                    
};
                        
struct statusdef_values_bluetooth_operation__contents_gatt_connection {                                                    
    char address_type[23 + 1];                
    struct statusdef_values_bluetooth_operation__contents_gatt_connection__address _address;                                                            
    char transport[15 + 1];                
    uint16_t connection_id;                
    uint16_t mtu;                    
    char time_connected[64 + 1];                            
};
                        
struct statusdef_values_bluetooth_operation__contents_paired_device {                                    
    char name[25 + 1];                    
    char address[17 + 1];            
};
                                                    
struct statusdef_values_bluetooth_nearby_devices__list_device {                                    
    char name[25 + 1];                    
    char address[17 + 1];                    
    char type[29 + 1];                
    int8_t rssi;                
    uint8_t scaled_rssi;                
    uint8_t is_bonded;            
};
                                            




















































                                                                                                                                                                    
    
                    
struct statusdef_values_bluetooth_operation__contents {                
    char local_device_address[17 + 1];            
    uint8_t number_of_rfcomm_servers;            
    struct statusdef_values_bluetooth_operation__contents_rfcomm_server rfcomm_server[3];                                                                                                                
    uint8_t number_of_rfcomm_connections;            
    struct statusdef_values_bluetooth_operation__contents_rfcomm_connection rfcomm_connection[4];                                                                                                                                                                            
    char ble_advertised_service_uuid[36 + 1];            
    uint8_t number_of_gatt_servers;            
    struct statusdef_values_bluetooth_operation__contents_gatt_server gatt_server[3];                                                                                                                                    
    uint8_t number_of_gatt_connections;            
    struct statusdef_values_bluetooth_operation__contents_gatt_connection gatt_connection[(6+2)];                                                                                                                                                                                                                            
    uint8_t number_of_paired_devices;            
    struct statusdef_values_bluetooth_operation__contents_paired_device paired_device[10];                                                                            
};
                                
struct statusdef_values_bluetooth_nearby_devices__list {            
    struct statusdef_values_bluetooth_nearby_devices__list_device device[40];                                                                                                                                                
};
                                    




















































                                                                                                                                                                    
    
    
struct statusdef_values_bluetooth_operation {        
    uint8_t state;        
    struct statusdef_values_bluetooth_operation__contents _contents;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
};
    
struct statusdef_values_bluetooth_nearby_devices {        
    struct statusdef_values_bluetooth_nearby_devices__list _list;                                                                                                                                                                                                
};





















































                                                                                                                                                                    
    

struct statusdef_values_bluetooth {    
    struct statusdef_values_bluetooth_operation operation;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
    struct statusdef_values_bluetooth_nearby_devices nearby_devices;                                                                                                                                                                                                        
};


extern const struct ltrx_module_info g_bluetoothModuleInfo;

