/* This file is automatically generated. */
/* DO NOT EDIT. */

#pragma once

/*****************************************************************************/
/*                              Legal                                        */
/*****************************************************************************/

/*
** Copyright 2015-2024, Lantronix, Inc. All Rights Reserved.
** By using this software, you are agreeing to the terms of the Software
** Development Kit (SDK) License Agreement included in the distribution package
** for this software (the License Agreement).
** Under the License Agreement, this software may be used solely to create
** custom applications for use on the Lantronix xPico Wi-Fi product.
** THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS PROVIDED "AS IS".
** LANTRONIX SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED
** TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT AND FITNESS
** FOR A PARTICULAR PURPOSE.
** LANTRONIX HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
** ENHANCEMENTS, OR MODIFICATIONS TO THIS SOFTWARE.
** IN NO EVENT SHALL LANTRONIX BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
** SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS,
** ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
** LANTRONIX HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*****************************************************************************/
/*                             Includes                                      */
/*****************************************************************************/

#include <stdarg.h>
#include <stdint.h>
#include <stdbool.h>
#include "ltrx_cfgvar.h"

/*****************************************************************************/
/*                       Generated Definitions                               */
/*****************************************************************************/

/* From define_external_include declarations: */



                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
/* Structures referenced by define_external_function declarations: */
struct ltrx_trigger;
struct ltrx_network_packet;


                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                

struct bridge_external_functions
{
    void (*ltrx_bridge_setup)(
        struct ltrx_trigger *optReceiveTrigger,
        void (*linkCallback)(bool linkIsUp),
        const char *bridgeClientName
    );
    void (*ltrx_bridge_control)(
        bool wantLinkUp
    );
    bool (*ltrx_bridge_is_up)(void
    );
    const char * (*ltrx_bridge_get_opt_client_name)(
        uint8_t zeroBasedInterface
    );
    void (*ltrx_bridge_notify_interface_state_change)(
        uint8_t zeroBasedInterface,
        bool newState
    );
    struct ltrx_network_packet * (*ltrx_bridge_receive)(void
    );

    bool (*ltrx_bridge_queue_inbound)(
        uint8_t zeroBasedInterface,
        struct ltrx_network_packet *packet
    );
    void (*ltrx_bridge_send)(
        struct ltrx_network_packet *p
    );
    bool (*ltrx_bridge_is_ethernet_enabled)(void
    );
    uint8_t (*ltrx_bridge_get_interface)(void
    );


    bool (*ltrx_bridge_get_igmp_ip_address)(
        uint8_t index,
        char *buffer,
        size_t length
    );
    bool (*ltrx_bridge_get_allow_all_multicast)(void
    );
    bool (*ltrx_bridge_register_wired_interface)(
        const char *name
    );                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
};

/* From vardef declarations: */




/* Begin index Bridge */
#define VARDEF_ELEMENT_GROUP_BRIDGE 1  
    
#define VARDEF_ENUM_BRIDGE_INTERFACE__DISABLED 0

#define VARDEF_ENUM_BRIDGE_INTERFACE__WLAN0 1

#define VARDEF_ENUM_BRIDGE_INTERFACE__AP0 2


#define VARDEF_ELEMENT_ITEM_BRIDGE_INTERFACE 2
#define VARDEF_NUMBER_195_HAS_ALREADY_BEEN_USED bridge-2 
    
/* Begin index -bridge_enabled */
#define VARDEF_ELEMENT_GROUP_BRIDGE__BRIDGE_ENABLED 3  
        
#define VARDEF_ELEMENT_ITEM_BRIDGE__BRIDGE_ENABLED_WIRED_INTERFACE 4
#define VARDEF_NUMBER_331_HAS_ALREADY_BEEN_USED bridge-4  
#define VARDEF_ELEMENT_ITEM_BRIDGE__BRIDGE_ENABLED_WIRED_INTERFACE_STRLEN_MAX 10
        
/* Suppressed index Ethernet */
            
/* Suppressed index -deprecated */
                
            
            
/* Suppressed index -wlan */
                
#define VARDEF_ENUM_BRIDGE__BRIDGE_ENABLED_ETHERNET__WLAN_MODE__DYNAMIC 1

#define VARDEF_ENUM_BRIDGE__BRIDGE_ENABLED_ETHERNET__WLAN_MODE__STATIC 2


                
/* Suppressed index -static */
                     
                
            
        
        
#define VARDEF_ELEMENT_ITEM_BRIDGE__BRIDGE_ENABLED_ALLOW_ALL_MULTICAST 5
#define VARDEF_NUMBER_604_HAS_ALREADY_BEEN_USED bridge-5 
        
/* Begin index IGMP */
#define VARDEF_ELEMENT_GROUP_BRIDGE__BRIDGE_ENABLED_IGMP 6  
            
            
#define VARDEF_ELEMENT_ITEM_BRIDGE__BRIDGE_ENABLED_IGMP_IP_ADDRESS 8
#define VARDEF_NUMBER_282_HAS_ALREADY_BEEN_USED bridge-8  
#define VARDEF_ELEMENT_ITEM_BRIDGE__BRIDGE_ENABLED_IGMP_IP_ADDRESS_STRLEN_MAX 15
        
/* End index IGMP */
#define VARDEF_ELEMENT_END_BRIDGE__BRIDGE_ENABLED_IGMP 9  
    
/* End index -bridge_enabled */
#define VARDEF_ELEMENT_END_BRIDGE__BRIDGE_ENABLED 10  

struct vardef_values_bridge;
bool BridgeTestSet(
    uint32_t zeroBasedIndex,
    struct vardef_values_bridge *config,
    bool set,
    const struct ltrx_write_user_message_info *lwumi
);
void BridgeConfigurationWarnings(
    uint32_t zeroBasedIndex,
    const struct ltrx_write_user_message_info *lwumi
);
/* End index Bridge */
#define VARDEF_ELEMENT_END_BRIDGE 11  
                                                                                                                                                                                                                                                                                                                                                        
/* Structures for groups of data */




                                                                                                                                                                                                        
                                                                                                                                                                                                                                                                                                                                                                                    


                                                                                                                                                                                                        
                                                                                                                                                                                                                                                                                                                                                                                    


                                                                                                                                                                                                        
                                                                                                                                                                                                                                                                                                                                                                                    


                                                                                                                                                                                            
struct vardef_values_bridge__bridge_enabled_igmp {            
                
    char ip_address[15 + 1];        
};
                                                                                                                                                                                                                                                                                                                                                            


        
struct vardef_values_bridge__bridge_enabled {            
    char wired_interface[10 + 1];                                                                                                                                                                
    bool allow_all_multicast;        
    struct vardef_values_bridge__bridge_enabled_igmp igmp[6];            
                            
};
                                                                                                                                                                                                                                                                                                                                                        



struct vardef_values_bridge {    
    uint8_t interface;    
    struct vardef_values_bridge__bridge_enabled _bridge_enabled;                                                                                                                                                                                                
                            
};
                                                                                                                                                                                                                                                                                                                                                        
/* From statusdef declarations: */



                                                                                                                                                                                                                         
#define STATUSDEF_ELEMENT_GROUP_BRIDGE 1 
    
#define STATUSDEF_ELEMENT_ITEM_BRIDGE_STATE 2 
#define STATUSDEF_ENUM_BRIDGE_STATE__DOWN 0 
#define STATUSDEF_ENUM_BRIDGE_STATE__UP 1 
    
#define STATUSDEF_ELEMENT_ITEM_BRIDGE_CLIENT_INTERFACE 3  
#define STATUSDEF_ELEMENT_ITEM_BRIDGE_CLIENT_INTERFACE_STRLEN_MAX 10
    
#define STATUSDEF_ELEMENT_ITEM_BRIDGE_CLIENT_STATE 4 
#define STATUSDEF_ENUM_BRIDGE_CLIENT_STATE__DOWN 0 
#define STATUSDEF_ENUM_BRIDGE_CLIENT_STATE__UP 1 
     
#define STATUSDEF_ELEMENT_GROUP_BRIDGE_INBOUND 5 
         
/* statusdef_index_information 6 */ 
        
#define STATUSDEF_ELEMENT_ITEM_BRIDGE_INBOUND_QUEUED_FRAMES 7 
        
#define STATUSDEF_ELEMENT_ITEM_BRIDGE_INBOUND_RECEIVED_FRAMES 8 
         
#define STATUSDEF_ELEMENT_GROUP_BRIDGE_INBOUND__NON_LEGACY 9 
            
#define STATUSDEF_ELEMENT_ITEM_BRIDGE_INBOUND__NON_LEGACY_REJECTED_FRAMES 10 
        
/* End index -non_legacy */ 
#define STATUSDEF_ELEMENT_END_BRIDGE_INBOUND__NON_LEGACY 11     
/* End index Inbound */ 
#define STATUSDEF_ELEMENT_END_BRIDGE_INBOUND 12      
#define STATUSDEF_ELEMENT_GROUP_BRIDGE_OUTBOUND 13 
         
/* statusdef_index_information 14 */ 
        
#define STATUSDEF_ELEMENT_ITEM_BRIDGE_OUTBOUND_SENT_FRAMES 15 
        
#define STATUSDEF_ELEMENT_ITEM_BRIDGE_OUTBOUND_DROPPED_FRAMES 16 
         
#define STATUSDEF_ELEMENT_GROUP_BRIDGE_OUTBOUND__NON_LEGACY 17 
            
#define STATUSDEF_ELEMENT_ITEM_BRIDGE_OUTBOUND__NON_LEGACY_REJECTED_FRAMES 18 
            
#define STATUSDEF_ELEMENT_ITEM_BRIDGE_OUTBOUND__NON_LEGACY_IGNORED_LOCAL_FRAMES 19 
        
/* End index -non_legacy */ 
#define STATUSDEF_ELEMENT_END_BRIDGE_OUTBOUND__NON_LEGACY 20     
/* End index Outbound */ 
#define STATUSDEF_ELEMENT_END_BRIDGE_OUTBOUND 21      
#define STATUSDEF_ELEMENT_GROUP_BRIDGE_CONFIGURED 22 
         
/* statusdef_index_information 23 */ 
        
#define STATUSDEF_ELEMENT_ITEM_BRIDGE_CONFIGURED_INTERFACE 24 
#define STATUSDEF_ENUM_BRIDGE_CONFIGURED_INTERFACE__DISABLED 0 
#define STATUSDEF_ENUM_BRIDGE_CONFIGURED_INTERFACE__WLAN0 1 
#define STATUSDEF_ENUM_BRIDGE_CONFIGURED_INTERFACE__AP0 2 
         
#define STATUSDEF_ELEMENT_GROUP_BRIDGE_CONFIGURED__BRIDGE_ENABLED 25 
            
#define STATUSDEF_ELEMENT_ITEM_BRIDGE_CONFIGURED__BRIDGE_ENABLED_WIRED_INTERFACE 26  
#define STATUSDEF_ELEMENT_ITEM_BRIDGE_CONFIGURED__BRIDGE_ENABLED_WIRED_INTERFACE_STRLEN_MAX 10
            
                
#define STATUSDEF_ENUM_BRIDGE_CONFIGURED__BRIDGE_ENABLED_ETHERNET_MODE__DYNAMIC 1 
#define STATUSDEF_ENUM_BRIDGE_CONFIGURED__BRIDGE_ENABLED_ETHERNET_MODE__STATIC 2 
                
                     
                
/* End index -mac */            
/* End index Ethernet */        
/* End index -bridge_enabled */ 
#define STATUSDEF_ELEMENT_END_BRIDGE_CONFIGURED__BRIDGE_ENABLED 27     
/* End index Configured */ 
#define STATUSDEF_ELEMENT_END_BRIDGE_CONFIGURED 28 
/* End index Bridge */
struct statusdef_values_bridge;
void BridgeStatus(
    uint32_t zeroBasedIndex,
    struct statusdef_values_bridge *status,
    const struct ltrx_write_user_message_info *lwumi
); 
#define STATUSDEF_ELEMENT_END_BRIDGE 29  
#define STATUSDEF_ELEMENT_GROUP_BRIDGED_DEVICES 30 
     
#define STATUSDEF_ELEMENT_GROUP_BRIDGED_DEVICES_DEVICE 31 
        
#define STATUSDEF_ELEMENT_ITEM_BRIDGED_DEVICES_DEVICE_INSTANCE 32  
#define STATUSDEF_ELEMENT_ITEM_BRIDGED_DEVICES_DEVICE_INSTANCE_STRLEN_MAX 17
         
/* statusdef_summary 33 */ 
        
#define STATUSDEF_ELEMENT_ITEM_BRIDGED_DEVICES_DEVICE_IPV4_ADDRESS 34  
#define STATUSDEF_ELEMENT_ITEM_BRIDGED_DEVICES_DEVICE_IPV4_ADDRESS_STRLEN_MAX 15
        
#define STATUSDEF_ELEMENT_ITEM_BRIDGED_DEVICES_DEVICE_SENT_FRAMES 35 
        
#define STATUSDEF_ELEMENT_ITEM_BRIDGED_DEVICES_DEVICE_RECEIVED_FRAMES 36 
        
#define STATUSDEF_ELEMENT_ITEM_BRIDGED_DEVICES_DEVICE_AGE 37 
    
/* End index Device */ 
#define STATUSDEF_ELEMENT_END_BRIDGED_DEVICES_DEVICE 38 
/* End index Bridged Devices */
struct statusdef_values_bridged_devices;
void BridgedDevicesStatus(
    uint32_t zeroBasedIndex,
    struct statusdef_values_bridged_devices *status,
    const struct ltrx_write_user_message_info *lwumi
); 
#define STATUSDEF_ELEMENT_END_BRIDGED_DEVICES 39 
/* Structures for groups of status */




                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    


                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    


                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    


                                                                                                                                                                                                                                                                            
struct statusdef_values_bridge_inbound__non_legacy {            
    uint64_t rejected_frames;        
};
                                        
struct statusdef_values_bridge_outbound__non_legacy {            
    uint64_t rejected_frames;            
    uint64_t ignored_local_frames;        
};
                                
struct statusdef_values_bridge_configured__bridge_enabled {                
    char wired_interface[10 + 1];                                                                                                        
};
                                                                    


                                                                                                                                                                                                                                            
struct statusdef_values_bridge_inbound {                
    uint16_t queued_frames;        
    uint64_t received_frames;        
    struct statusdef_values_bridge_inbound__non_legacy _non_legacy;                        
};
    
struct statusdef_values_bridge_outbound {                
    uint64_t sent_frames;        
    uint64_t dropped_frames;        
    struct statusdef_values_bridge_outbound__non_legacy _non_legacy;                                    
};
    
struct statusdef_values_bridge_configured {                
    uint8_t interface;        
    struct statusdef_values_bridge_configured__bridge_enabled _bridge_enabled;                                                                                                                            
};
    
struct statusdef_values_bridged_devices_device {            
    char instance[17 + 1];                    
    char ipv4_address[15 + 1];        
    uint64_t sent_frames;        
    uint64_t received_frames;        
    uint32_t age;    
};



                                                                                                                                                                                                                        
struct statusdef_values_bridge {    
    uint8_t state;        
    char client_interface[10 + 1];    
    uint8_t client_state;    
    struct statusdef_values_bridge_inbound inbound;                                                            
    struct statusdef_values_bridge_outbound outbound;                                                                        
    struct statusdef_values_bridge_configured configured;                                                                                                                                                    
};

struct statusdef_values_bridged_devices {    
    struct statusdef_values_bridged_devices_device device[20];                                                            
};

extern const struct ltrx_module_info g_bridgeModuleInfo;

