/* This file is automatically generated. */
/* DO NOT EDIT. */

#pragma once

/*****************************************************************************/
/*                              Legal                                        */
/*****************************************************************************/

/*
** Copyright 2015-2024, Lantronix, Inc. All Rights Reserved.
** By using this software, you are agreeing to the terms of the Software
** Development Kit (SDK) License Agreement included in the distribution package
** for this software (the License Agreement).
** Under the License Agreement, this software may be used solely to create
** custom applications for use on the Lantronix xPico Wi-Fi product.
** THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS PROVIDED "AS IS".
** LANTRONIX SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED
** TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT AND FITNESS
** FOR A PARTICULAR PURPOSE.
** LANTRONIX HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
** ENHANCEMENTS, OR MODIFICATIONS TO THIS SOFTWARE.
** IN NO EVENT SHALL LANTRONIX BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
** SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS,
** ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
** LANTRONIX HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*****************************************************************************/
/*                             Includes                                      */
/*****************************************************************************/

#include <stdarg.h>
#include <stdint.h>
#include <stdbool.h>
#include "ltrx_cfgvar.h"

/*****************************************************************************/
/*                       Generated Definitions                               */
/*****************************************************************************/

/* From define_external_include declarations: */

/* Structures referenced by define_external_function declarations: */
struct ltrx_mqtt_client;
struct ltrx_mqtt_client_network_info;
struct ltrx_mqtt_client_connect_info;
struct ltrx_mqtt_message;
struct ltrx_mqtt_message_data;

struct mqtt_external_functions
{
    struct ltrx_mqtt_client * (*ltrx_mqtt_client_create)(
        uint32_t command_timeout_ms,
        size_t sendbuf_size,
        size_t recvbuf_size
    );
    int (*ltrx_mqtt_client_destroy)(
        struct ltrx_mqtt_client *lmc
    );
    int (*ltrx_mqtt_client_set_log_verbosity)(
        struct ltrx_mqtt_client *lmc,
        uint8_t verbosity
    );
    int (*ltrx_mqtt_client_set_network_info)(
        struct ltrx_mqtt_client *lmc,
        struct ltrx_mqtt_client_network_info *lmcni
    );
    int (*ltrx_mqtt_client_set_connect_info)(
        struct ltrx_mqtt_client *lmc,
        const struct ltrx_mqtt_client_connect_info *lmcci
    );
    int (*ltrx_mqtt_client_set_lwt)(
        struct ltrx_mqtt_client *lmc,
        const char *topic,
        struct ltrx_mqtt_message *msg
    );
    int (*ltrx_mqtt_client_set_cleansession)(
        struct ltrx_mqtt_client *lmc,
        bool cleansession
    );
    int (*ltrx_mqtt_client_set_keepalive_interval)(
        struct ltrx_mqtt_client *lmc,
        uint16_t keepalive_interval_sec
    );
    int (*ltrx_mqtt_client_connect)(
        struct ltrx_mqtt_client *lmc
    );
    bool (*ltrx_mqtt_client_is_connected)(
        struct ltrx_mqtt_client *lmc
    );
    int (*ltrx_mqtt_client_disconnect)(
        struct ltrx_mqtt_client *lmc
    );
    int (*ltrx_mqtt_client_publish)(
        struct ltrx_mqtt_client *lmc,
        const char *topic,
        struct ltrx_mqtt_message *msg
    );
    int (*ltrx_mqtt_client_subscribe)(
        struct ltrx_mqtt_client *lmc,
        const char *topic_filter,
        int max_qos,
        void *opaque,
        void (*callback)(struct ltrx_mqtt_message_data *, void *)
    );
    int (*ltrx_mqtt_client_unsubscribe)(
        struct ltrx_mqtt_client *lmc,
        const char *topic_filter
    );
};

/* From vardef declarations: */

/* Structures for groups of data */


/* From statusdef declarations: */

/* Structures for groups of status */


extern const struct ltrx_module_info g_mqttModuleInfo;

