/* This file is automatically generated. */
/* DO NOT EDIT. */

#pragma once

/*****************************************************************************/
/*                              Legal                                        */
/*****************************************************************************/

/*
** Copyright 2015-2024, Lantronix, Inc. All Rights Reserved.
** By using this software, you are agreeing to the terms of the Software
** Development Kit (SDK) License Agreement included in the distribution package
** for this software (the License Agreement).
** Under the License Agreement, this software may be used solely to create
** custom applications for use on the Lantronix xPico Wi-Fi product.
** THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS PROVIDED "AS IS".
** LANTRONIX SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED
** TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT AND FITNESS
** FOR A PARTICULAR PURPOSE.
** LANTRONIX HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
** ENHANCEMENTS, OR MODIFICATIONS TO THIS SOFTWARE.
** IN NO EVENT SHALL LANTRONIX BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
** SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS,
** ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
** LANTRONIX HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*****************************************************************************/
/*                             Includes                                      */
/*****************************************************************************/

#include <stdarg.h>
#include <stdint.h>
#include <stdbool.h>
#include "ltrx_cfgvar.h"

/*****************************************************************************/
/*                       Generated Definitions                               */
/*****************************************************************************/

/* From define_external_include declarations: */

                                                                                                                                                                                                            	        	                                                                                                                                                                                                                                                                                
/* Structures referenced by define_external_function declarations: */
struct input_stream_from_uart;
struct output_stream_to_uart;
struct output_stream;
struct input_stream;
                                                                                                                                                                                                            	        	                                                                                                                                                                                                                                                                                

struct percepxion_external_functions
{
    bool (*ltrx_percepxion_is_line_enabled)(
        uint16_t zeroBasedIndex
    );
    int (*ltrx_percepxion_serial_api_interpret_and_execute)(
        const volatile bool *quit,
        struct input_stream_from_uart *inputStream,
        struct output_stream_to_uart *outputStream
    );
    int (*ltrx_percepxion_get_device_settings)(
        const volatile bool *quit,
        struct output_stream *outputStream,
        uint16_t zeroBasedIndex
    );
    int (*ltrx_percepxion_register_device)(
        const volatile bool *quit,
        struct input_stream *inputStream,
        struct output_stream *outputStream
    );
    int (*ltrx_percepxion_update_status)(
        const volatile bool *quit,
        struct input_stream *inputStream,
        struct output_stream *outputStream,
        const char *authToken
    );
    int (*ltrx_percepxion_get_available_updates)(
        const volatile bool *quit,
        struct input_stream *inputStream,
        struct output_stream *outputStream,
        const char *authToken
    );
    int (*ltrx_percepxion_download_update)(
        const volatile bool *quit,
        struct input_stream *inputStream,
        struct output_stream *outputStream,
        const char *authToken
    );
    void (*ltrx_percepxion_config_from_flash)(
        void
    );
                                                                                                                                                                                                            	        	                                                                                                                                                                                                                                                                                
};

/* From vardef declarations: */


/* Begin index Percepxion */
#define VARDEF_ELEMENT_GROUP_PERCEPXION 1  
    
/* Begin index Device */
#define VARDEF_ELEMENT_GROUP_PERCEPXION_DEVICE 2  
        
/* Suppressed index deprecated_state */
            
        
        
#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_STATE 3
#define VARDEF_NUMBER_310_HAS_ALREADY_BEEN_USED percepxion-3 
        

#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_STATUS_UPDATE_INTERVAL 4
#define VARDEF_NUMBER_261_HAS_ALREADY_BEEN_USED percepxion-4 
        

#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_CONTENT_CHECK_INTERVAL 5
#define VARDEF_NUMBER_262_HAS_ALREADY_BEEN_USED percepxion-5 
        
#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_APPLY_FIRMWARE_UPDATES 6
#define VARDEF_NUMBER_263_HAS_ALREADY_BEEN_USED percepxion-6 
        
#define VARDEF_ENUM_PERCEPXION_DEVICE_APPLY_CONFIGURATION_UPDATES__NEVER 0

#define VARDEF_ENUM_PERCEPXION_DEVICE_APPLY_CONFIGURATION_UPDATES__IF_UNCHANGED 1

#define VARDEF_ENUM_PERCEPXION_DEVICE_APPLY_CONFIGURATION_UPDATES__ALWAYS 2


#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_APPLY_CONFIGURATION_UPDATES 7
#define VARDEF_NUMBER_264_HAS_ALREADY_BEEN_USED percepxion-7 
        
#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_REBOOT_AFTER_CONFIG_UPDATE 8
#define VARDEF_NUMBER_265_HAS_ALREADY_BEEN_USED percepxion-8 
        
#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_DEVICE_NAME 9
#define VARDEF_NUMBER_266_HAS_ALREADY_BEEN_USED percepxion-9  
#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_DEVICE_NAME_STRLEN_MAX 63
        
#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_DEVICE_DESCRIPTION 10
#define VARDEF_NUMBER_267_HAS_ALREADY_BEEN_USED percepxion-10  
#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_DEVICE_DESCRIPTION_STRLEN_MAX 63
        
#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_ADDITIONAL_LOGGING 11
#define VARDEF_NUMBER_274_HAS_ALREADY_BEEN_USED percepxion-11 
        

#define VARDEF_ENUM_PERCEPXION_DEVICE_ACTIVE_CONNECTION__1 0
#define VARDEF_ENUM_PERCEPXION_DEVICE_ACTIVE_CONNECTION__2 1



#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_ACTIVE_CONNECTION 12
#define VARDEF_NUMBER_281_HAS_ALREADY_BEEN_USED percepxion-12 
        
/* Begin index Connection */
#define VARDEF_ELEMENT_GROUP_PERCEPXION_DEVICE_CONNECTION 13  
            
            
            
#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_CONNECTION_DOMAIN 16
#define VARDEF_NUMBER_268_HAS_ALREADY_BEEN_USED percepxion-16  
#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_CONNECTION_DOMAIN_STRLEN_MAX 63
            

#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_CONNECTION_LOCAL_PORT 17
#define VARDEF_NUMBER_269_HAS_ALREADY_BEEN_USED percepxion-17 
            
#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_CONNECTION_MQTT_STATE 18
#define VARDEF_NUMBER_276_HAS_ALREADY_BEEN_USED percepxion-18 
            
/* Suppressed index -DEPRECATE_MQTT_DOMAIN */
            	 
        	    	
            

#define VARDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_CONNECTION_MQTT_LOCAL_PORT 19
#define VARDEF_NUMBER_278_HAS_ALREADY_BEEN_USED percepxion-19 
        
/* End index Connection */
#define VARDEF_ELEMENT_END_PERCEPXION_DEVICE_CONNECTION 20  
    
struct vardef_values_percepxion_device;
bool Mach10DeviceTestSet(
    uint32_t zeroBasedIndex,
    struct vardef_values_percepxion_device *config,
    bool set,
    const struct ltrx_write_user_message_info *lwumi
);
void Mach10DeviceWarnings(
    uint32_t zeroBasedIndex,
    const struct ltrx_write_user_message_info *lwumi
);
/* End index Device */
#define VARDEF_ELEMENT_END_PERCEPXION_DEVICE 21  
    
/* Begin index Line */
#define VARDEF_ELEMENT_GROUP_PERCEPXION_LINE 22  
        
        
#define VARDEF_ELEMENT_ITEM_PERCEPXION_LINE_STATE 24
#define VARDEF_NUMBER_270_HAS_ALREADY_BEEN_USED percepxion-24 
        
#define VARDEF_ELEMENT_ITEM_PERCEPXION_LINE_PROJECT_TAG 25
#define VARDEF_NUMBER_271_HAS_ALREADY_BEEN_USED percepxion-25  
#define VARDEF_ELEMENT_ITEM_PERCEPXION_LINE_PROJECT_TAG_STRLEN_MAX 63
        

#define VARDEF_ELEMENT_ITEM_PERCEPXION_LINE_STATUS_UPDATE_INTERVAL 26
#define VARDEF_NUMBER_273_HAS_ALREADY_BEEN_USED percepxion-26 
        

#define VARDEF_ELEMENT_ITEM_PERCEPXION_LINE_CONTENT_CHECK_INTERVAL 27
#define VARDEF_NUMBER_272_HAS_ALREADY_BEEN_USED percepxion-27 
    
struct vardef_values_percepxion_line;
bool Mach10LineTestSet(
    uint32_t zeroBasedIndex,
    struct vardef_values_percepxion_line *config,
    bool set,
    const struct ltrx_write_user_message_info *lwumi
);
void Mach10LineWarnings(
    uint32_t zeroBasedIndex,
    const struct ltrx_write_user_message_info *lwumi
);
/* End index Line */
#define VARDEF_ELEMENT_END_PERCEPXION_LINE 28  

/* End index Percepxion */
#define VARDEF_ELEMENT_END_PERCEPXION 29  
                                                                                                                                                                                                        
/* Structures for groups of data */


                                                                                                                                            
            
                                                                	            	                                    
                                                                                                                                                                                                                                                
                                                                                                                                            
            
                                                                	            	                                    
                                                                                                                                                                                                                                                
                                                                                                                                            
            
                                                                	            	                                    
                                                                                                                                                                                                                                                
                                                                                                                                
struct vardef_values_percepxion_device_connection {            
            
                
    char domain[63 + 1];            
    uint16_t local_port;            
    bool mqtt_state;                        	            	            
    uint16_t mqtt_local_port;        
};
                
                                                                                                                                                                                                                                                
    
struct vardef_values_percepxion_device {                                    
    bool state;        
    uint16_t status_update_interval;        
    uint16_t content_check_interval;        
    bool apply_firmware_updates;        
    uint8_t apply_configuration_updates;        
    bool reboot_after_config_update;            
    char device_name[63 + 1];            
    char device_description[63 + 1];        
    bool additional_logging;        
    uint8_t active_connection;        
    struct vardef_values_percepxion_device_connection connection[2];            
            
                                                                	            	                        
};
    
struct vardef_values_percepxion_line {        
        
    bool state;            
    char project_tag[63 + 1];        
    uint16_t status_update_interval;        
    uint16_t content_check_interval;    
};
                                                                                                                                                                                                        

struct vardef_values_percepxion {    
    struct vardef_values_percepxion_device device;                                                                                                                                        
            
                                                                	            	                            
    struct vardef_values_percepxion_line line[20];        
                                        
};
                                                                                                                                                                                                        
/* From statusdef declarations: */

                                                                                                                                                                                                            	        	                                                                         
#define STATUSDEF_ELEMENT_GROUP_PERCEPXION 1 
    
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_STATE 2  
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_STATE_STRLEN_MAX 32
    
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_ID 3  
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_DEVICE_ID_STRLEN_MAX 32
     
#define STATUSDEF_ELEMENT_GROUP_PERCEPXION_STATUS 4 
         
/* statusdef_index_information 5 */ 
        
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_STATUS_LAST_STATUS_UPDATE 6  
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_STATUS_LAST_STATUS_UPDATE_STRLEN_MAX 23
        
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_STATUS_LAST_CONTENT_CHECK 7  
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_STATUS_LAST_CONTENT_CHECK_STRLEN_MAX 23
        
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_STATUS_UPDATES_AVAILABLE 8 
    
/* End index Status */ 
#define STATUSDEF_ELEMENT_END_PERCEPXION_STATUS 9      
#define STATUSDEF_ELEMENT_GROUP_PERCEPXION_AVAILABLE_UPDATE 10 
         
/* statusdef_index_information 11 */ 
         
/* statusdef_summary 12 */ 
        
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_AVAILABLE_UPDATE_TYPE 13  
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_AVAILABLE_UPDATE_TYPE_STRLEN_MAX 15
        
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_AVAILABLE_UPDATE_VERSION 14  
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_AVAILABLE_UPDATE_VERSION_STRLEN_MAX 32
        
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_AVAILABLE_UPDATE_NAME 15  
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_AVAILABLE_UPDATE_NAME_STRLEN_MAX 32
        
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_AVAILABLE_UPDATE_DESCRIPTION 16  
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_AVAILABLE_UPDATE_DESCRIPTION_STRLEN_MAX 100
        
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_AVAILABLE_UPDATE_ID 17  
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_AVAILABLE_UPDATE_ID_STRLEN_MAX 40
        
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_AVAILABLE_UPDATE_SIZE 18  
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_AVAILABLE_UPDATE_SIZE_STRLEN_MAX 23
        
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_AVAILABLE_UPDATE_STATE 19  
#define STATUSDEF_ELEMENT_ITEM_PERCEPXION_AVAILABLE_UPDATE_STATE_STRLEN_MAX 31
    
/* End index Available Update */ 
#define STATUSDEF_ELEMENT_END_PERCEPXION_AVAILABLE_UPDATE 20     
        
        
        
        
        
        
    
/* End index -Export */    
        
    
/* End index -Import */
/* End index Percepxion */
struct statusdef_values_percepxion;
void Mach10Status(
    uint32_t zeroBasedIndex,
    struct statusdef_values_percepxion *status,
    const struct ltrx_write_user_message_info *lwumi
); 
#define STATUSDEF_ELEMENT_END_PERCEPXION 21 
/* Structures for groups of status */


                                                                                                                                                                                                            	        	                                                                                                                                                                                                                                                                                                                            
                                                                                                                                                                                                            	        	                                                                                                                                                                                                                                                                                                                            
                                                                                                                                                                                                            	        	                                                                                                                                                                                                                                                                                                                            
                                                                                                                                                                                                            	        	                                                                                                                                                                                                                                                                                                                            
                                                                                                                                                                                                            	        	                                                                                            
struct statusdef_values_percepxion_status {                    
    char last_status_update[23 + 1];            
    char last_content_check[23 + 1];        
    uint16_t updates_available;    
};
    
struct statusdef_values_percepxion_available_update {                            
    char type[15 + 1];            
    char version[32 + 1];            
    char name[32 + 1];            
    char description[100 + 1];            
    char id[40 + 1];            
    char size[23 + 1];            
    char state[31 + 1];    
};
                                                                        
                                                                                                                                                                                                            	        	                                                                        
struct statusdef_values_percepxion {        
    char state[32 + 1];        
    char device_id[32 + 1];    
    struct statusdef_values_percepxion_status status[1];                                                
    struct statusdef_values_percepxion_available_update available_update[20];                                                                                                                                                                                
};

extern const struct ltrx_module_info g_percepxionModuleInfo;

