/* This file is automatically generated. */
/* DO NOT EDIT. */

#pragma once

/*****************************************************************************/
/*                              Legal                                        */
/*****************************************************************************/

/*
** Copyright 2015-2024, Lantronix, Inc. All Rights Reserved.
** By using this software, you are agreeing to the terms of the Software
** Development Kit (SDK) License Agreement included in the distribution package
** for this software (the License Agreement).
** Under the License Agreement, this software may be used solely to create
** custom applications for use on the Lantronix xPico Wi-Fi product.
** THIS SOFTWARE AND ANY ACCOMPANYING DOCUMENTATION IS PROVIDED "AS IS".
** LANTRONIX SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED
** TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT AND FITNESS
** FOR A PARTICULAR PURPOSE.
** LANTRONIX HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
** ENHANCEMENTS, OR MODIFICATIONS TO THIS SOFTWARE.
** IN NO EVENT SHALL LANTRONIX BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
** SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST PROFITS,
** ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
** LANTRONIX HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*****************************************************************************/
/*                             Includes                                      */
/*****************************************************************************/

#include <stdarg.h>
#include <stdint.h>
#include <stdbool.h>
#include "ltrx_cfgvar.h"

/*****************************************************************************/
/*                       Generated Definitions                               */
/*****************************************************************************/

/* From define_external_include declarations: */
#include "ltrx_snmp.h"

                                                                                                                                                        	                          
/* Structures referenced by define_external_function declarations: */                                                                                                                                                        	                          

struct snmp_external_functions
{
    bool (*SnmpMibHandlerRegister)(
        const OID *baseOid,
        const MIB *mib

    );
    bool (*SnmpMibHandlerUnregister)(
        const OID *baseOid

    );
    unsigned int (*SnmpTrap)(
        const uint8_t *contextName,
        const uint8_t *oid,
        uint16_t oidLen,
        const uint8_t *vbs,
        uint16_t vbsLen

    );
    unsigned int
 (*SnmpTrapColdStart)(void
    );
    unsigned int
 (*SnmpTrapWarmStart)(void
    );
    unsigned int
 (*SnmpTrapLinkDown)(void
    );
    unsigned int
 (*SnmpTrapLinkUp)(void
    );
    bool (*SnmpInform)(
        const uint8_t *contextName,
        const uint8_t *oid,
        uint16_t oidLen,
        const uint8_t *vbs,
        uint16_t vbsLen,
        const char *to,
        uint32_t timeoutMsec,
        uint32_t *errorStatus,
        uint32_t *errorIndex

    );                                                                                                                                                        	                          
};

/* From vardef declarations: */

/* Begin index SNMP */
#define VARDEF_ELEMENT_GROUP_SNMP 1  
    
#define VARDEF_ELEMENT_ITEM_SNMP_STATE 2
#define VARDEF_NUMBER_340_HAS_ALREADY_BEEN_USED snmp-2 
    
/* Begin index -Config */
#define VARDEF_ELEMENT_GROUP_SNMP__CONFIG 3  
      
/* Begin index -network */
#define VARDEF_ELEMENT_GROUP_SNMP__CONFIG__NETWORK 4  
          
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG__NETWORK_LISTEN_INTERFACE 5
#define VARDEF_NUMBER_350_HAS_ALREADY_BEEN_USED snmp-5  
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG__NETWORK_LISTEN_INTERFACE_STRLEN_MAX 5
      
/* End index -network */
#define VARDEF_ELEMENT_END_SNMP__CONFIG__NETWORK 6  
      
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_COMMUNITY_READ 7
#define VARDEF_NUMBER_341_HAS_ALREADY_BEEN_USED snmp-7  
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_COMMUNITY_READ_STRLEN_MAX 64
      
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_COMMUNITY_WRITE 8
#define VARDEF_NUMBER_342_HAS_ALREADY_BEEN_USED snmp-8  
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_COMMUNITY_WRITE_STRLEN_MAX 64
      
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_SYSTEM_CONTACT 9
#define VARDEF_NUMBER_343_HAS_ALREADY_BEEN_USED snmp-9  
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_SYSTEM_CONTACT_STRLEN_MAX 64
      
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_SYSTEM_NAME 10
#define VARDEF_NUMBER_344_HAS_ALREADY_BEEN_USED snmp-10  
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_SYSTEM_NAME_STRLEN_MAX 64
      
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_SYSTEM_DESCRIPTION 11
#define VARDEF_NUMBER_345_HAS_ALREADY_BEEN_USED snmp-11  
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_SYSTEM_DESCRIPTION_STRLEN_MAX 64
      
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_SYSTEM_LOCATION 12
#define VARDEF_NUMBER_346_HAS_ALREADY_BEEN_USED snmp-12  
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_SYSTEM_LOCATION_STRLEN_MAX 64
      
/* Begin index Traps */
#define VARDEF_ELEMENT_GROUP_SNMP__CONFIG_TRAPS 13  
          
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_TRAPS_STATE 14
#define VARDEF_NUMBER_347_HAS_ALREADY_BEEN_USED snmp-14 
          
/* Begin index -ip */
#define VARDEF_ELEMENT_GROUP_SNMP__CONFIG_TRAPS__IP 15  
            
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_TRAPS__IP_PRIMARY_DESTINATION 16
#define VARDEF_NUMBER_348_HAS_ALREADY_BEEN_USED snmp-16  
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_TRAPS__IP_PRIMARY_DESTINATION_STRLEN_MAX 64
            
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_TRAPS__IP_SECONDARY_DESTINATION 17
#define VARDEF_NUMBER_349_HAS_ALREADY_BEEN_USED snmp-17  
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_TRAPS__IP_SECONDARY_DESTINATION_STRLEN_MAX 64
          
/* End index -ip */
#define VARDEF_ELEMENT_END_SNMP__CONFIG_TRAPS__IP 18  
      
/* End index Traps */
#define VARDEF_ELEMENT_END_SNMP__CONFIG_TRAPS 19  
      
/* Begin index Extended Agent */
#define VARDEF_ELEMENT_GROUP_SNMP__CONFIG_EXTENDED_AGENT 20  
        
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_EXTENDED_AGENT_IP_ADDRESS 21
#define VARDEF_NUMBER_608_HAS_ALREADY_BEEN_USED snmp-21  
#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_EXTENDED_AGENT_IP_ADDRESS_STRLEN_MAX 31
      	

#define VARDEF_ELEMENT_ITEM_SNMP__CONFIG_EXTENDED_AGENT_PORT 22
#define VARDEF_NUMBER_605_HAS_ALREADY_BEEN_USED snmp-22 
      
/* End index Extended Agent */
#define VARDEF_ELEMENT_END_SNMP__CONFIG_EXTENDED_AGENT 23  
    
/* End index -Config */
#define VARDEF_ELEMENT_END_SNMP__CONFIG 24      

struct vardef_values_snmp;
bool SnmpTestSet(
    uint32_t zeroBasedIndex,
    struct vardef_values_snmp *config,
    bool set,
    const struct ltrx_write_user_message_info *lwumi
);
void SnmpWarnings(
    uint32_t zeroBasedIndex,
    const struct ltrx_write_user_message_info *lwumi
);
/* End index SNMP */
#define VARDEF_ELEMENT_END_SNMP 25  
                
/* Structures for groups of data */

                                                                                                                                                                                                	                                                                                                                                                                                                                          	                                                                                                                                                  
struct vardef_values_snmp__config_traps__ip {                
    char primary_destination[64 + 1];                
    char secondary_destination[64 + 1];          
};
                              	                                        
struct vardef_values_snmp__config__network {              
    char listen_interface[5 + 1];      
};
                                                                  
struct vardef_values_snmp__config_traps {          
    bool state;          
    struct vardef_values_snmp__config_traps__ip _ip;                                                
};
      
struct vardef_values_snmp__config_extended_agent {            
    char ip_address[31 + 1];      	
    uint16_t port;      
};
                            
struct vardef_values_snmp__config {      
    struct vardef_values_snmp__config__network _network;                              
    char community_read[64 + 1];          
    char community_write[64 + 1];          
    char system_contact[64 + 1];          
    char system_name[64 + 1];          
    char system_description[64 + 1];          
    char system_location[64 + 1];      
    struct vardef_values_snmp__config_traps traps;                                                                          
    struct vardef_values_snmp__config_extended_agent extended_agent;                  	          
};
                
struct vardef_values_snmp {    
    bool state;    
    struct vardef_values_snmp__config _config;                                                                                                                                                                                        	          
};
                
/* From statusdef declarations: */
                                                                                                                                                        	           
#define STATUSDEF_ELEMENT_GROUP_SNMP 1 
    
#define STATUSDEF_ELEMENT_ITEM_SNMP_SNMP_AGENT 2 
#define STATUSDEF_ENUM_SNMP_SNMP_AGENT__NOT_RUNNING 0 
#define STATUSDEF_ENUM_SNMP_SNMP_AGENT__RUNNING 1 
    
#define STATUSDEF_ELEMENT_ITEM_SNMP_SYSTEM_NAME 3  
#define STATUSDEF_ELEMENT_ITEM_SNMP_SYSTEM_NAME_STRLEN_MAX 64
    
#define STATUSDEF_ELEMENT_ITEM_SNMP_SYSTEM_DESCRIPTION 4  
#define STATUSDEF_ELEMENT_ITEM_SNMP_SYSTEM_DESCRIPTION_STRLEN_MAX 64
    
#define STATUSDEF_ELEMENT_ITEM_SNMP_EXTENDED_AGENT 5  
#define STATUSDEF_ELEMENT_ITEM_SNMP_EXTENDED_AGENT_STRLEN_MAX 9

/* End index SNMP */
struct statusdef_values_snmp;
void SnmpGetStatus(
    uint32_t zeroBasedIndex,
    struct statusdef_values_snmp *status,
    const struct ltrx_write_user_message_info *lwumi
); 
#define STATUSDEF_ELEMENT_END_SNMP 6 
/* Structures for groups of status */

                                                                                                                                                        	                                                                                                                                                                                              	                                                                                                                                                                                              	                                                                                                                                                                                              	                                                                                                                                                                                              	                                                                                                                                                                                              	          
struct statusdef_values_snmp {    
    uint8_t snmp_agent;        
    char system_name[64 + 1];        
    char system_description[64 + 1];        
    char extended_agent[9 + 1];
};

extern const struct ltrx_module_info g_snmpModuleInfo;

